<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Task Chains">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>About Task Chains</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#12-task-chains/about-task-chains.html">Open topic with navigation</a>
        </p>
        <h1>About Task Chains</h1>
        <p style="font-weight: normal;"><a name="kanchor197"></a>Task chains enable you to   automate and schedule the execution of a series of preconfigured tasks. They are useful for automating repetitive tasks that you need to perform regularly, such as scans and bruteforce attacks. </p>
        <p style="font-weight: normal;"> A task chain comprises of a sequence of predefined tasks that you can schedule to run on a recurring basis or save to run on demand. It defines the tasks that will run, the settings for each task, and the conditions  required for the execution of those tasks. You create a task chain by adding the tasks you want to it, configuring the settings you want the tasks to use, arranging the tasks in the order you want them to run, and defining the schedule that it should follow. </p>
        <p style="font-weight: normal;">Task chains are particularly useful if you  want to run a sequence of tasks, but do not want to  wait for each task to finish before you can run the next task.  For example, if you routinely scan and bruteforce a set of targets hosts, you can string the tasks together so that they run sequentially at a specified time and date. </p>
        <h2><a name="Task"></a>Task Chain&#160;UI Tour</h2>
        <p>Task chains tasks are separated into two different areas:</p>
        <ul>
            <li value="1"><b>Task chains list</b> - Displays all the task chains that are stored in the project. From this list, you can bulk manage task chains, view the current status for a task chain, view the contents of the task chain, and identify when a task chain will run next.</li>
            <li value="2"><b>Task chain configuration page</b> - Displays the contents of a task chain. From this page, you can  add, configure, and rearrange tasks, and you can create the schedule for the task chain. </li>
        </ul>
        <h3>Task Chains List </h3>
        <p>You can access the task chains list to perform the following tasks: </p>
        <ul>
            <li value="1">Create a new task chain</li>
            <li value="2">Delete task chains</li>
            <li value="3">Clone task chains</li>
            <li value="4">Suspend task chains</li>
            <li value="5">Run task chains</li>
            <li value="6">View the current status for a task chain</li>
            <li value="7">View the last time the task chain was run</li>
            <li value="8">View the tasks that comprise a task chain</li>
        </ul>
        <p>To access the task chains list, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-list-view_563x205.png" title="Task Chains List" alt="Task Chains List" style="width: 563;height: 205;" />
        </p>
        <ol>
            <li value="1"><b>New Task Chain button</b> - Opens the New&#160;Task Chain configuration page. </li>
            <li value="2"><b>Task chain bulk management buttons</b> -  Bulk manages task chains. You can do things like delete, clone, suspend, and run multiple task chains at once. <br /></li>
            <li value="3"><b>Task chains list</b> - Lists all of the task chains that have been created for the project. <br /><br />Each task chain will have one of the following schedule icons:</li>
        </ol>
        <ul>
            <li class="indentedList" value="1"><em>Recurring Schedule</em> - Indicates that the task chain repeatedly runs at a specified time and day. </li>
            <li class="indentedList" value="2"><em>Single Schedule</em> - Indicates that the task chain is scheduled to run once at a specified time and date. </li>
            <li class="indentedList" value="3"><em>Not Scheduled</em> - Indicates that the task chain does not follow a schedule. </li>
            <li class="indentedList" value="4"><em>Suspended</em> - Indicates that the task chain is inactive. <br /></li>
        </ul>
        <ol start="4">
            <li value="4"><b>Task chain status</b> - Displays one of the following statuses for each task chain:</li>
        </ol>
        <ul>
            <li class="indentedList" value="1"><em>Never run</em> - The task chain has never run. </li>
            <li class="indentedList" value="2"><em>Running</em> - The task chain is currently running. </li>
            <li class="indentedList" value="3"><em>Last run</em> - The task chain last ran successfully at the specified date.</li>
            <li class="indentedList" value="4"><em>Failed</em> - The task chain was unable to finish successfully. If the task chain failed, it will display a link that you can click on to open the Task log and view the errors that occurred. </li>
        </ul>
        <h3>Task Chain Configuration Page </h3>
        <p>You access the task chain configuration page to create a new task chain or to modify an existing task chain. </p>
        <p>To access the task chain configuration page, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar. When the task chains list appears, click the <b class="UISelection">New Task Chain</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-config-page-3_551x287.png" title="Task Chains Configuration  Page" alt="Task Chains Configuration  Page" style="width: 551;height: 287;" />
        </p>
        <ol>
            <li value="1"><b>Task Chain Name field</b> - Displays an editable field for the task chain name. You can click on the field at any time to edit its name. </li>
            <li value="2"><b>Schedule status</b> - Indicates whether or not a schedule has been created for the task chain. <br /><br />It displays one of the following statuses:</li>
        </ol>
        <ul>
            <li class="numberedList2" value="1"><em>Scheduled</em> - Indicates that a schedule has been created for the task chain. </li>
            <li class="numberedList2" value="2"><em>Unscheduled</em> - Indicates that a schedule has not been created for the task chain.</li>
        </ul>
        <ol data-mc-continue="true">
            <li value="3"><b>Schedule Now link</b> - Opens the Task Chain&#160;Scheduler, which enables you to schedule and suspend task chains. Additionally, you can enable the option to clear project data before the task chain runs. </li>
            <li value="4"><b>Save and Run button</b> - Saves the current task chain configuration and immediately runs the task chain. </li>
            <li value="5"><b>Save button</b> - Saves the current task chain configuration. The task chain will be available for you to run on demand or it will run according to the schedule that you have created for it. </li>
            <li value="6"><b>Delete task</b> - Removes the selected task from the task chain. </li>
            <li value="7"><b>Clone task</b> - Duplicates the selected task and adds it to the end of the task chain. </li>
            <li value="8"><b>Reset task configuration</b> - Clears all tasks from the task chain. </li>
            <li value="9"><b>Task bubble</b> - Represents a task. You can click on a task bubble to open the task configuration form. The selected task bubble will be highlighted in blue.<br /><br />Any task highlighted in red indicates that the task has not been configured correctly and the task chain cannot be saved. You can click on the task to fix the issues on the task form. <br /><br />You can also click and drag the task bubble to move the task to a new position in the task chain. </li>
            <li value="10"><b>Add Task button</b> - Displays the task list and enables you to select the task that you want to add to the task chain. </li>
            <li value="11"><b>Task configuration form</b> - Displays the options that you can configure for the task that is selected. Options will vary depending on the task that is selected. </li>
        </ol>
        <h2><a name="Supporte"></a>Supported Tasks </h2>
        <p>Task chains can be used to execute the following tasks:</p>
        <ul>
            <li value="1"><b>Discovery scan</b> - Enumerate and fingerprint hosts on a target network.</li>
            <li value="2"><b>Import</b> - Bring in data from supported third-party scanners, such as Nexpose and Nessus.</li>
            <li value="3"><b>Vulnerability scan</b> - Scan a target network  with Nexpose to find vulnerabilities on a target network. </li>
            <li value="4"><b>Web scan</b> - Scan web forms and applications  to find and exploit active content and forms.</li>
            <li value="5"><b>Bruteforce</b> - Systematically attempt various combination of letters, numbers, and characters to crack credentials. </li>
            <li value="6"><b>Auto-exploitation</b> - Automatically build an attack play by cross-referencing open ports, imported vulnerabilities, and fingerprint information to exploit modules. </li>
            <li value="7"><b>Single module run</b> - Launch a module to perform targeted attacks against hosts or to gather additional data about hosts. You can add multiple modules to a task chain. </li>
            <li value="8"><b>MetaModules run</b> - Launch one of the following MetaModules: the Single Password Testing MetaModule, the Known Credentials MetaModule, the SSH&#160;Key Testing MetaModule, the Pass the Hash MetaModule, the Firewall Egress Testing MetaModule, or the Passive Network Discovery MetaModule.</li>
            <li value="9"><b>Evidence collection</b> - Collect evidence, such as screenshots, password hashes, and system files, from compromised hosts.</li>
            <li value="10"><b>Session clean up</b> - Close any open sessions on compromised hosts. </li>
            <li value="11"><b>Report generation</b> - Create a report to document findings and share test results. </li>
        </ul>
        <p><a class="MCHelpControl MCHelpControl-Related relatedTopics" data-mc-topics="Adding a Post-Exploitation Module to a Task Chain|creating-scheduling-running-task-chains.html#Adding2||Adding a Task to a Task Chain&#xA;|creating-scheduling-running-task-chains.html#Adding||Cleaning Up Open Sessions |managing-and-editing-task-chains.html#Cleaning||Clearing the Project Data before a Task Chain Runs |creating-scheduling-running-task-chains.html#Clearing||Cloning a Task |creating-scheduling-running-task-chains.html#Cloning||Creating a Task Chain |creating-scheduling-running-task-chains.html#Creating||Editing a Task Chain |managing-and-editing-task-chains.html#Editing||Rearranging Tasks in a Task Chain&#xA;|creating-scheduling-running-task-chains.html#Rearrang||Running a Task Chain |creating-scheduling-running-task-chains.html#Running||Suspending a Task Chain |managing-and-editing-task-chains.html#Suspendi||Task Chain Schedules|scheduling-task-chains.html#top"><span class="MCHelpControl-RelatedHotSpot_">Related Topics</span></a>
        </p>
    </body>
</html>